--- jdmarker.c.org	1998-02-21 23:24:50.000000000 +0300
+++ jdmarker.c	2005-12-28 23:48:32.000000000 +0300
@@ -278,8 +278,27 @@
   
   for (ci = 0, compptr = cinfo->comp_info; ci < cinfo->num_components;
        ci++, compptr++) {
+    int component_id;
+    int j;
     compptr->component_index = ci;
-    INPUT_BYTE(cinfo, compptr->component_id, return FALSE);
+    INPUT_BYTE(cinfo, component_id, return FALSE);
+    for (j = 0; j < ci; j++) {
+      /* Check to see whether component id has already been seen
+	 (in violation of the spec, but unfortunately seen in some
+	 files). If so, create "fake" component id equal to the
+	 max id seen so far + 1. */
+      if (cinfo->comp_info[j].component_id == component_id) {
+	int max_id = cinfo->comp_info[0].component_id;
+	int k;
+	for (k = 1; k < ci; k++) {
+	  int k_id = cinfo->comp_info[k].component_id;
+	  if (k_id > max_id) max_id = k_id;
+	}
+	component_id = max_id + 1;
+	break;
+      }
+    }
+    compptr->component_id = component_id;
     INPUT_BYTE(cinfo, c, return FALSE);
     compptr->h_samp_factor = (c >> 4) & 15;
     compptr->v_samp_factor = (c     ) & 15;
@@ -323,9 +342,25 @@
   /* Collect the component-spec parameters */
 
   for (i = 0; i < n; i++) {
+    int j;
     INPUT_BYTE(cinfo, cc, return FALSE);
     INPUT_BYTE(cinfo, c, return FALSE);
-    
+
+    /* Detect the case where component id's are not unique, and, if so,
+       create a fake component id using the same logic as in get_sof. */
+    for (j = 0; j < i; j++) {
+      if (cc == cinfo->cur_comp_info[j]->component_id) {
+	int k;
+	int max_id = cinfo->cur_comp_info[0]->component_id;
+	for (k = 1; k < i; k++) {
+	  int k_id = cinfo->cur_comp_info[k]->component_id;
+	  if (k_id > max_id) max_id = k_id;
+	}
+	cc = max_id + 1;
+	break;
+      }
+    }
+
     for (ci = 0, compptr = cinfo->comp_info; ci < cinfo->num_components;
 	 ci++, compptr++) {
       if (cc == compptr->component_id)
